/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.konfigass;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.SortedMap;
import java.util.TreeMap;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.Platform;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ArrayContentProvider;
import org.eclipse.jface.viewers.DoubleClickEvent;
import org.eclipse.jface.viewers.IDoubleClickListener;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.ui.IViewReference;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;

import de.bsvrz.puk.config.configFile.datamodel.ConfigDataModel;

/**
 * @author Pittner
 *
 */
public class KonfigAssDarstellungAssistenten extends Composite
{
  private Composite _composite;

  private Composite composite1;

  private TableViewer _tvZufluesse1;

  private Composite composite22 = null;

  private Composite composite25 = null;

  private Button button2 = null;

  private Composite composite = null;

  private Composite composite2 = null;

  private Composite composite3 = null;

  private Group group = null;

  private Group group1 = null;

  private Composite composite4 = null;
  
  private String _secondId = null;

  public KonfigAssDarstellungAssistenten(Composite parent, int style, String secondId)
  {
    super(parent, style);
    _secondId = secondId; 
    initialize();
  }

  /**
   * Fhrt die Basis-Initialisierung des Composites durch
   */
  private void initialize()
  {
    GridData gridData1 = new GridData();
    gridData1.horizontalAlignment = GridData.FILL;
    gridData1.grabExcessHorizontalSpace = true;
    gridData1.grabExcessVerticalSpace = true;
    gridData1.heightHint = -1;
    gridData1.widthHint = -1;
    gridData1.horizontalIndent = 0;
    gridData1.verticalAlignment = GridData.FILL;
    setLayout(new GridLayout(1, false));
    this.setSize(new Point(770, 561));
    setLayoutData(gridData1);
    GridLayout gridLayout = new GridLayout();
    gridLayout.makeColumnsEqualWidth = false;
    gridLayout.numColumns = 1;
    GridData gridData2 = new GridData();
    gridData2.horizontalAlignment = GridData.FILL;
    gridData2.grabExcessHorizontalSpace = true;
    gridData2.grabExcessVerticalSpace = true;
    gridData2.heightHint = -1;
    gridData2.widthHint = -1;
    gridData2.horizontalIndent = 0;
    gridData2.verticalAlignment = GridData.FILL;
    GridData gridData3 = new GridData();
    gridData3.horizontalAlignment = GridData.FILL;
    gridData3.grabExcessHorizontalSpace = true;
    gridData3.grabExcessVerticalSpace = true;
    gridData3.heightHint = -1;
    gridData3.widthHint = -1;
    gridData3.horizontalIndent = 0;
    gridData3.verticalAlignment = GridData.FILL;
    _composite = new Composite(this, SWT.NONE);
    _composite.setLayoutData(gridData2);
    _composite.setLayout(gridLayout);

    erzeugeCompositeOben();
    erzeugeCompositeUnten();
    
    //Fr die F1 Taste
    PlatformUI.getWorkbench().getHelpSystem().setHelp(this, Activator.PLUGIN_ID + ".assistenten");
   }

  private void erzeugeTabelleTeilkonfigurationsassistenten()
  {
    FillLayout fillLayout = new FillLayout();
    fillLayout.type = org.eclipse.swt.SWT.HORIZONTAL;
    composite1 = new Composite(composite4, SWT.None);
    composite1.setLayout(fillLayout);
    _tvZufluesse1 = new TableViewer(composite1, SWT.CHECK | SWT.FULL_SELECTION | SWT.MULTI | SWT.H_SCROLL
        | SWT.V_SCROLL);

    TableViewerColumn tc1 = new TableViewerColumn(_tvZufluesse1, SWT.NONE);
    tc1.getColumn().setWidth(60);
    tc1.getColumn().setText("Auswahl");
    TableViewerColumn tc2 = new TableViewerColumn(_tvZufluesse1, SWT.NONE);
    tc2.getColumn().setWidth(90);
    tc2.getColumn().setText("Kurzbezeichnung");
    TableViewerColumn tc3 = new TableViewerColumn(_tvZufluesse1, SWT.NONE);
    tc3.getColumn().setWidth(500);
    tc3.getColumn().setText("Beschreibung");

    _tvZufluesse1.setContentProvider(new TabelleTeilkonfigurationsassistentenInhaltsVersorger());
    _tvZufluesse1.setLabelProvider(new TabelleTeilkonfigurationsassistentenDarstellungsVersorger());

    _tvZufluesse1.getTable().setLinesVisible(true);
    _tvZufluesse1.getTable().setHeaderVisible(true);

    _tvZufluesse1.addDoubleClickListener(new IDoubleClickListener() {

      @Override
      public void doubleClick(DoubleClickEvent event)
      {
        TableItem[] selection = _tvZufluesse1.getTable().getSelection();
        oeffneTkaAusSelektion(selection);
      }
    });

  }

  /**
   * @param list
   */
  public void setInputTabelle(List<IKonfigAssDatenModell> list)
  {

    if (_tvZufluesse1 != null && list != null)
    {
      // _tvZufluesse1.setInput(list);

      for (IKonfigAssDatenModell kadm : list)
      {

        TableItem[] items = _tvZufluesse1.getTable().getItems();

        boolean vorhanden = false;

        for (int i = 0; i < items.length; i++)
        {
          TableItem ti = items[i];
          String id = (String)ti.getData("id");
          if (id.equals(kadm.holePluginId()))
            vorhanden = true;

        }

        if (!vorhanden)
        {
          TableItem ti = new TableItem(_tvZufluesse1.getTable(), SWT.NONE);
          ti.setText(1, kadm.holeName());
          ti.setText(2, kadm.holeBeschreibung());
          ti.setData("id", kadm.holePluginId());
        }

      }

      _tvZufluesse1.getTable().addListener(SWT.Selection, new Listener() {
        public void handleEvent(Event event)
        {
          updateButton(); 
        }
      });
      
      
//      IWorkbenchPage page = Workbench.getInstance().getActiveWorkbenchWindow().getActivePage();
//      
//      if (page != null){
//        IViewReference[] refs = page.getViewReferences();
//        for (IViewReference ref : refs)
//        {
//          System.out.println("ref: " + ref.getId());
//          
//          if (!ref.getId().equals(KonfigAssSicht.ID)){
//            
//            String partName = ref.getPartName();
//            System.out.println("partName: " + partName);
//            
//            if (partName.startsWith("TKA ")){
//              String[] split = partName.split(" ");
//              if (split.length > 1){
//                String secId = split[1];
//                if (secId != null)
//                {
//                  String ss = secId.toLowerCase();
//                  
//                  String id = "de.bsvrz.buv.plugin.tka" + ss;
//                  
//                  System.out.println("Part: " + id);
//                  
//                  TableViewer tv = holeTableViewerTeilKonfigurationsAssistenten();
//                  
//                  TableItem[] items = tv.getTable().getItems();
//                  
//                  System.out.println("items: " + items.length);
//                  
//                  for (TableItem ti : items)
//                  {
//                    String tiId = (String)ti.getData("id");
//                    
//                    System.out.println(id + " : " + tiId);
//                    
//                    if (id.equals(tiId)){
//                      ti.setChecked(false);
//                    }            
//                  }                          
//                }
//              }             
//            }
//          }        
//        }      
//      }
    }
  }

  /**
   * @author Pittner
   * 
   */
  private class TabelleTeilkonfigurationsassistentenInhaltsVersorger implements IStructuredContentProvider
  {

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.jface.viewers.IStructuredContentProvider#getElements(java.lang.Object)
     */
    public Object[] getElements(Object inputElement)
    {
      java.util.List list = (java.util.List)inputElement;

      Object[] re = new Object[list.size()];

      for (int i = 0; i < list.size(); i++)
      {
        re[i] = list.get(i);
      }

      return re;
    }

    /*
     * (non-Javadoc) *
     * 
     * @see org.eclipse.jface.viewers.IContentProvider#dispose()
     */
    public void dispose()
    {

    }

    /*
     * (non-Javadoc) *
     * 
     * @see org.eclipse.jface.viewers.IContentProvider#inputChanged(org.eclipse.jface.viewers.Viewer, java.lang.Object,
     * java.lang.Object)
     */
    public void inputChanged(Viewer viewer, Object oldInput, Object newInput)
    {

    }
  }

  /**
   * {@link LabelProvider} fr die Tabelle.
   * 
   * @author HofmannJ
   * 
   */
  private class TabelleTeilkonfigurationsassistentenDarstellungsVersorger implements ITableLabelProvider
  {

    @Override
    public Image getColumnImage(Object element, int columnIndex)
    {
      return null;
    }

    @Override
    public String getColumnText(Object element, int columnIndex)
    {
      String returnString = null;

      switch (columnIndex)
      {
        case 0:
          returnString = (String)element;
          break;
        default:
          returnString = "default";
      }
      return returnString;
    }

    @Override
    public void addListener(ILabelProviderListener listener)
    {
    }

    @Override
    public void dispose()
    {
    }

    @Override
    public boolean isLabelProperty(Object element, String property)
    {
      return false;
    }

    @Override
    public void removeListener(ILabelProviderListener listener)
    {
    }

  }

  public TableViewer holeTableViewerTeilKonfigurationsAssistenten()
  {
    return _tvZufluesse1;
  }

  /**
   * This method initializes composite22
   * 
   */
  private void erzeugeCompositeOben()
  {
    GridData gridData4 = new GridData();
    gridData4.horizontalAlignment = GridData.FILL;
    gridData4.grabExcessHorizontalSpace = true;
    gridData4.grabExcessVerticalSpace = true;
    gridData4.verticalAlignment = GridData.FILL;
    composite22 = new Composite(_composite, SWT.NONE);
    composite22.setLayout(new GridLayout());
    erzeugeCompositeGroupOben();
    composite22.setLayoutData(gridData4);
  }

  /**
   * This method initializes composite25
   * 
   */
  private void erzeugeCompositeOeffnen()
  {
    GridData gridData13 = new GridData();
    gridData13.horizontalAlignment = GridData.END;
    gridData13.grabExcessHorizontalSpace = true;
    gridData13.verticalAlignment = GridData.CENTER;
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    gridData.verticalAlignment = GridData.CENTER;
    // composite25 = new Composite(composite23, SWT.NONE);
    composite25 = new Composite(group, SWT.NONE);
    composite25.setLayout(new GridLayout());
    composite25.setLayoutData(gridData);
    button2 = new Button(composite25, SWT.NONE);
    button2.setText("Teilkonfigurationsassistenten ffnen...");
    button2.setLayoutData(gridData13);
//    button2.setEnabled(false);
    button2.addSelectionListener(new SelectionListener() {

      @Override
      public void widgetSelected(SelectionEvent e)
      {
        // TODO Auto-generated method stub
        TableItem[] items = _tvZufluesse1.getTable().getItems();
        List<TableItem> openItems = new LinkedList<TableItem>();

        for (int i = 0; i < items.length; i++)
        {
          TableItem ti = items[i];

          if (ti.getChecked())
          {
             if (!oeffneExtension(ti))
             {
               openItems.add(ti);
             }
          }
        }
        behandleGeoeffneteTKA(openItems);
      }

      @Override
      public void widgetDefaultSelected(SelectionEvent e)
      {
        // TODO Auto-generated method stub

      }
    });
    button2.setEnabled(false);
//    button2.addSelectionListener(new SelectionAdapter() {
//
//      @Override
//      public void widgetSelected(SelectionEvent e)
//      {
//        TableItem[] selection = _tvZufluesse1.getTable().getSelection();
//
//        List<TableItem> list = new ArrayList<TableItem>();
//        
//        for (TableItem ti : selection)
//        {
//          if (ti.getChecked())
//            list.add(ti);
//        }
//        
//        
//        TableItem[] items = list.toArray(new TableItem[list.size()]);
//        
//        oeffneTkaAusSelektion(items);
//
//      }
//
//    });
  }

   
  /**
   * This method initializes composite
   * 
   */
  private void erzeugeCompositeGroupOben()
  {
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    gridData.grabExcessVerticalSpace = true;
    gridData.verticalAlignment = GridData.FILL;
    composite = new Composite(composite22, SWT.NONE);
    composite.setLayout(new GridLayout());
    erzeugeGroupOben();
    composite.setLayoutData(gridData);
  }


  /**
   * Holt die registrierten Teilkonfigurationsassistenten
   * 
   * @return die Liste der TKA
   */
  public List<IKonfigAssDatenModell> holeAngemeldeteAssistenten()
  {
    SortedMap<String, IKonfigAssDatenModell> sortMap = new TreeMap<String, IKonfigAssDatenModell>();

    IConfigurationElement[] configurationElementsFor = Platform.getExtensionRegistry().getConfigurationElementsFor(
        "de.bsvrz.buv.plugin.konfigass.konfigAssDatenModell");

    for (IConfigurationElement ce : configurationElementsFor)
    {
      IKonfigAssDatenModell operation;
      try
      {
        operation = (IKonfigAssDatenModell)ce.createExecutableExtension("konfigAssDatenModellKlasse");

        String name = operation.holeName();

        if (name != null)
          sortMap.put(name, operation);
      }
      catch (CoreException e)
      {
        // TODO Auto-generated catch block
        e.printStackTrace();
      }
    }
   
    return new ArrayList<IKonfigAssDatenModell>(sortMap.values());
  }

  /**
   * This method initializes composite2
   * 
   */
  private void erzeugeCompositeUnten()
  {
    GridData gridData6 = new GridData();
    gridData6.horizontalAlignment = GridData.FILL;
    gridData6.grabExcessHorizontalSpace = true;
    gridData6.heightHint = -1;
    gridData6.verticalAlignment = GridData.CENTER;
    composite2 = new Composite(_composite, SWT.NONE);
    composite2.setLayout(new GridLayout());
    erzeugeCompositeGroupUnten();
    composite2.setLayoutData(gridData6);
  }

  /**
   * This method initializes composite3
   * 
   */
  private void erzeugeCompositeGroupUnten()
  {
    GridData gridData7 = new GridData();
    gridData7.horizontalAlignment = GridData.FILL;
    gridData7.grabExcessHorizontalSpace = true;
    gridData7.verticalAlignment = GridData.CENTER;
    composite3 = new Composite(composite2, SWT.NONE);
    composite3.setLayout(new GridLayout());
    erzeugeGroupUnten();
    composite3.setLayoutData(gridData7);
  }

  /**
   * This method initializes group
   * 
   */
  private void erzeugeGroupUnten()
  {
    GridData gridData8 = new GridData();
    gridData8.horizontalAlignment = GridData.FILL;
    gridData8.grabExcessHorizontalSpace = true;
    gridData8.verticalAlignment = GridData.CENTER;
    group = new Group(composite3, SWT.NONE);
    group.setLayout(new GridLayout());
    erzeugeCompositeOeffnen();
    // erzeugeCompositeGroupUnten2();
    group.setLayoutData(gridData8);
  }

  /**
   * This method initializes group1
   * 
   */
  private void erzeugeGroupOben()
  {
    GridData gridData11 = new GridData();
    gridData11.horizontalAlignment = GridData.FILL;
    gridData11.grabExcessHorizontalSpace = true;
    gridData11.grabExcessVerticalSpace = true;
    gridData11.verticalAlignment = GridData.FILL;
    group1 = new Group(composite, SWT.NONE);
    group1.setLayout(new GridLayout());
    group1.setText("Registrierte Teilkonfigurationsassistenten");
    erzeugeCompositeTabelle();
    group1.setLayoutData(gridData11);

    erzeugeTabelleTeilkonfigurationsassistenten();
  }

  /**
   * This method initializes composite4
   * 
   */
  private void erzeugeCompositeTabelle()
  {
    GridData gridData12 = new GridData();
    gridData12.horizontalAlignment = GridData.FILL;
    gridData12.grabExcessHorizontalSpace = true;
    gridData12.grabExcessVerticalSpace = true;
    gridData12.verticalAlignment = GridData.FILL;
    composite4 = new Composite(group1, SWT.NONE);
    composite4.setLayout(new FillLayout());
    composite4.setLayoutData(gridData12);
  }

  private void oeffneTkaAusSelektion(TableItem[] selection)
  {
    List<TableItem> openItems = new LinkedList<TableItem>();
    
    for (TableItem ti : selection)
    {
      ti.setChecked(true);
      if (!oeffneExtension(ti))
      {
        openItems.add(ti);
      }
    }
    
    behandleGeoeffneteTKA(openItems);
  }
  
  private boolean ermittleObTkaGeoeffnet(String pluginId)
  {
    IWorkbench wb = PlatformUI.getWorkbench();
    IWorkbenchWindow ww = wb.getActiveWorkbenchWindow();
    IWorkbenchPage page = ww.getActivePage();

    IViewReference[] vrs = page.getViewReferences();
    
    for (IViewReference ref : vrs)
    {      
      if (ref.getId().equals("de.bsvrz.buv.plugin.tkabasis.tkaBasisView"))
      {
        if (pluginId.startsWith("de.bsvrz.buv.plugin.tka"))
        {
          String secId = pluginId.substring(pluginId.indexOf("tka") + 3);
          if (ref.getSecondaryId() != null && ref.getSecondaryId().toLowerCase().equals(secId))
          {
            return true;
          }
        } 
      }
    }
    
    return false;
  }
  
  public Button getButtonOeffnen()
  {
    return button2;
  }
  
  private boolean oeffneExtension(TableItem ti)
  {
    String id = (String)ti.getData("id");
    
    if (ermittleObTkaGeoeffnet(id))
    {
      return false;
    }
    else
    {  
      IKonfigAssDatenModell kadm = null;
      IConfigurationElement[] configurationElementsFor = Platform.getExtensionRegistry().getConfigurationElementsFor(
        "de.bsvrz.buv.plugin.konfigass.konfigAssDatenModell");
      
      for (IConfigurationElement ce : configurationElementsFor)
      {
        IKonfigAssDatenModell operation;
        try
        {
          operation = (IKonfigAssDatenModell)ce.createExecutableExtension("konfigAssDatenModellKlasse");
          if (operation.holePluginId().equals(id))
          {
            kadm = operation;
            break;
          }
        }
        catch (CoreException e)
        {
          // TODO Auto-generated catch block
          e.printStackTrace();
        }
      }
      
      if (kadm != null)
      {
        KonfigAssSicht view = KonfigAssSicht.getView(_secondId);
        
        if (!view.getDarstellungKonfigurationComposite().getZugeordnetePluginIds().contains(id))
        {
          // Falls Plugin noch nicht zugewiesen
          ConfigDataModel dm = view.getDarstellungKonfigurationComposite().getConfig();
          String pfad = view.getDarstellungKonfigurationComposite()._dateiPfad;
          kadm.setzeKonfigDatenModell(dm, pfad);
          view.addZugeordnetePluginId(id);
          
          // Entferne zugeordnete PluginId aus allen andern KonfigAss Views
          IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
          IWorkbenchPage page = dw.getActivePage();
          for (IViewReference ref: page.getViewReferences())
          {
            if (ref.getId().equals(KonfigAssSicht.ID))
            {
              String secId = ref.getSecondaryId();
              if ((secId != null && !secId.equals(_secondId)) || (secId == null && _secondId != null))
              {
                KonfigAssSicht kav = (KonfigAssSicht)ref.getView(false);
                if (kav != null)
                {
                  if (kav.getDarstellungKonfigurationComposite().getZugeordnetePluginIds().contains(id))
                  {
                    kav.removeZugeordnetePluginId(id);
                    for (TableItem item: kav.getDarstellungAssisitentenComposite()._tvZufluesse1.getTable().getItems())
                    {
                      if (id.equals(item.getData("id")))
                      {
                        item.setChecked(false);
                      }
                    }
                  }
                }
              }
            }
          }
        }
        
        // Zugeordnete Aktion ausfhren
        IAction aktion = kadm.holeAktion();
        
        if (aktion != null)
        {
          aktion.run();
        }
      }
      return true;
    }  
  }  
  
    
  private void behandleGeoeffneteTKA(List<TableItem> items)
  {
    if (items != null && ! items.isEmpty())
    {
      // ffne Listdialog
    	KonfigAssListDialog listDialog = new KonfigAssListDialog(PlatformUI.getWorkbench().getDisplay().getActiveShell());
      listDialog.setTitle("TKA kann nur einmal geffnet werden");
      listDialog.setMessage("Folgende TKA sind bereits geffnet\n- evtl. im Kontext einer anderen Konfiguration:");
      listDialog.setAddCancelButton(false);
      listDialog.setContentProvider(new ArrayContentProvider());
      listDialog.setLabelProvider(new LabelProvider());
      listDialog.setHelpContext(Activator.PLUGIN_ID + ".ass_limit");
      
      List<String> liste = new LinkedList<String>();
      for (TableItem ti: items)
      {
        liste.add(ti.getText(1));
      }
      listDialog.setInput(liste);
      listDialog.open();
      
      // Aktualisiere Checkboxen
      for (TableItem ti: items)
      {
        if (ti.getChecked())
        {
          String id = (String)ti.getData("id");
          KonfigAssSicht view = KonfigAssSicht.getView(_secondId); 
          if (!view.getDarstellungKonfigurationComposite().getZugeordnetePluginIds().contains(id))
          {
            ti.setChecked(false); 
          }
        }
      }
      updateButton();
    }
  }
  
  private void updateButton()
  {
    TableItem[] items = _tvZufluesse1.getTable().getItems();
  
    boolean oeffnenMoeglich = false;
  
    for (int i = 0; i < items.length; i++)
    {
      TableItem ti = items[i];
  
      if (ti.getChecked())
        oeffnenMoeglich = true;
    }
  
    if (oeffnenMoeglich)
      button2.setEnabled(true);
    else
      button2.setEnabled(false);
  }  

 
} // @jve:decl-index=0:visual-constraint="10,10"
