/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.konfigass.assistenten;
import java.io.File;
import java.util.Map;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.ui.INewWizard;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchWizard;

/**
 * Wizard class
 */
public class KbEntfernenHinzufuegenAssistent extends Wizard implements INewWizard
{
	public static final String copyright = "(c) Copyright IBM Corporation 2002.";	
	// wizard pages
	KbHinzufuegenEntfernenStartSeite seiteStart;	
	// the model
	KbEntfernenHinzufuegenModell model;
	
  public KbEntfernenHinzufuegenModell getModel()
  {
    return model;
  }

  public void setModel(KbEntfernenHinzufuegenModell model)
  {
    this.model = model;
  }

  // workbench selection when the wizard was started
	protected IStructuredSelection selection;
	
	// flag indicated whether the wizard can be completed or not 
	// if the user has selected plane as type of transport
	protected boolean seiteStartCompleted = false;

	 
	// the workbench instance
	protected IWorkbench workbench;
  
	private String _dateiPfad;
  
  private boolean  _neu;

	/**
	 * Constructor for HolidayMainWizard.
	 */
	public KbEntfernenHinzufuegenAssistent(String pidAoe, boolean neu, Map<String, File> list) {
	  this(pidAoe, neu);		
		 model._list = list;
	}
	
	/**
	 * Constructor for HolidayMainWizard.
	 */
	public KbEntfernenHinzufuegenAssistent(String dateiPfad, boolean neu) {
	  super();
	  _neu = neu;
	  _dateiPfad = dateiPfad;	  
	  model = new KbEntfernenHinzufuegenModell();
	}
	
	public void addPages()
	{
	  seiteStart = new KbHinzufuegenEntfernenStartSeite(_dateiPfad, _neu);
	  addPage(seiteStart);
	}

	/**
	 * @see IWorkbenchWizard#init(IWorkbench, IStructuredSelection)
	 */
	public void init(IWorkbench workbench, IStructuredSelection selection) 
	{
		this.workbench = workbench;
		this.selection = selection;
//		if (selection != null && !selection.isEmpty()) {
//			Object obj = selection.getFirstElement();
//			if (obj  instanceof IFolder) {
//				IFolder folder = (IFolder) obj;				
//				if (folder.getName().equals("Discounts"))
//					model.useKV = true;			
//			}
//		}
	}

	public boolean canFinish()
	{
		// cannot completr the wizard from the first page
//		if (this.getContainer().getCurrentPage() == planePage) 
//			return false;
		// based on the type of transport return the right flag			
		return seiteStartCompleted;
	}
	
	public boolean performFinish() 
	{		
		return true;
	}
	
}
