/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.konfigass.assistenten;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.jface.dialogs.IDialogPage;
import org.eclipse.jface.viewers.ArrayContentProvider;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IWorkbench;

/**
 * Class representing the first page of the wizard
 */

public class KbHinzufuegenEntfernenStartSeite extends WizardPage implements Listener
{

  public static final String copyright = "(c) Copyright IBM Corporation 2002.";

  IWorkbench workbench;

  IStructuredSelection selection;

  Button kvButton;

  Button aoeButton;

  // status variable for the possible errors on this page
  // timeStatus holds an error if the return date is before the departure date
  IStatus timeStatus;

  // holds an error is the destination and departure fields are the same
  IStatus destinationStatus;

  private Label labelName;

  private Label labelBeschreibung;

  private Text textName;

  private Label labelQuelle;

  private Text textPid;

  private Label labelQuelle1;

  private Text textOrtKonfig;

  private Button button;

  private String _dateiPfad;

  protected String _name;

  private Label labelQuelle2;

  private Text textOrtOrdner;

  private Button button2;

  private Label labelKodierung;

  private Text textKodierung;
  
  
  

  //
  // final static String[] dates = { "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15",
  // "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31" };
  //
  // final static String[] months = { "January", "February", "March", "April", "May", "June", "July", "August",
  // "September", "October", "November", "December" };
  //
  // final static String[] years;
  //
  // final static int startingYear;

  private Shell shell;

  private File _source;

  private File _dest;

  private TableViewer _tvZufluesse1;

  private boolean _neu;

  // static
  // {
  // Calendar cal = Calendar.getInstance();
  // cal.setTime(new Date());
  // startingYear = cal.get(Calendar.YEAR);
  // years = new String[3];
  // for (int i = -1; i < 2; i++)
  // {
  // years[i + 1] = String.valueOf(startingYear + i);
  // }
  // }

  /**
   * Constructor for HolidayMainPage.
   */
  public KbHinzufuegenEntfernenStartSeite(String dateiPfad, boolean neu)
  {
    super("Page1");
    _neu = neu;

    if (neu){
      setTitle("KB hinzufgen");
      setDescription("Folgende ausgewhlte Konfigurationsbereiche werden hinzugefgt:");
    }
    else{
      setTitle("KB entfernen");
      setDescription("Folgende ausgewhlte Konfigurationsbereiche werden entfernt:");
    }
    
    destinationStatus = new Status(IStatus.OK, "not_used", 0, "", null);
    timeStatus = new Status(IStatus.OK, "not_used", 0, "", null);
    _dateiPfad = dateiPfad;

  }

  /**
   * @see IDialogPage#createControl(Composite)
   */
  public void createControl(Composite parent)
  {
    shell = parent.getShell();

    // create the composite to hold the widgets
    GridData gd = new GridData();
    gd.horizontalAlignment = GridData.FILL;
    gd.grabExcessHorizontalSpace = true;
    gd.grabExcessVerticalSpace = true;
    gd.verticalAlignment = GridData.BEGINNING;
    Composite composite = new Composite(parent, SWT.NULL);

    composite.setLayout(new GridLayout(2, false));
    composite.setLayoutData(gd);

    _tvZufluesse1 = new TableViewer(composite, SWT.BORDER | SWT.CHECK | SWT.FULL_SELECTION | SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL);

    TableViewerColumn tc1 = new TableViewerColumn(_tvZufluesse1, SWT.NONE);
    tc1.getColumn().setWidth(20);
    tc1.getColumn().setText("Auswahl");
    // tc1.getColumn().pack();
    TableViewerColumn tc2 = new TableViewerColumn(_tvZufluesse1, SWT.NONE);
    tc2.getColumn().setWidth(300);
    tc2.getColumn().setText("Menge");

    _tvZufluesse1.setContentProvider(new ArrayContentProvider());
    _tvZufluesse1.setLabelProvider(new TabelleTeilkonfigurationsassistentenDarstellungsVersorger());

    _tvZufluesse1.getTable().setLayout(new FillLayout());
    GridData gd2 = new GridData(GridData.FILL_BOTH);
    
    _tvZufluesse1.getTable().setLayoutData(gd2);

    if (_neu)
    {
      button = new Button(composite, SWT.NONE);
      button.setText("...");    
      button.setLayoutData(new GridData(SWT.TOP, SWT.TOP, false, false));
      button.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(SelectionEvent e)
        {
          // TODO Auto-generated method stub
          FileDialog dialog = new FileDialog(Display.getCurrent().getActiveShell(), SWT.APPLICATION_MODAL
              | SWT.DIALOG_TRIM | SWT.RESIZE | SWT.MULTI | SWT.OPEN);
          dialog.setFilterNames(new String[] { "CONFIG-Dateien" });
          dialog.setFilterExtensions(new String[] { "*.config" });
          
          File temp = new File(_dateiPfad);
          String path = temp.getParent();
          if (path != null)
          {
            temp = new File(path + "/../" + "config");
            if (temp.exists())
            {
              path += "/../" + "config";
            }
            else
            {  
              temp = new File(path + "/../" + "konfiguration");
              if (temp.exists())
              {
                path += "/../" + "konfiguration";
              }
            }  
            dialog.setFilterPath(path);
          }
          
          String dateiPfad = dialog.open();
          
          if (dateiPfad != null)
          {
            File datei = new File(dateiPfad);
            String folderName = datei.getParent();
            
            String[] fileNames = dialog.getFileNames();
            
            Map<String, File> map = new HashMap<String, File>();
            
            for (String s : fileNames)
            {         
              String ss = folderName + "/" + s;
              
              File file = new File(ss);              
              TableItem ti = new TableItem(_tvZufluesse1.getTable(), SWT.NONE);
              ti.setText(1, file.getName());  
              ti.setChecked(true);
              map.put(file.getName(), file);             
            }
            
            KbEntfernenHinzufuegenAssistent wizard = (KbEntfernenHinzufuegenAssistent)getWizard();
            
//            wizard.model._list = map;
//            
//            wizard.model._pfad = dateiPfad;
            
            wizard.model.getList().putAll(map);
            
            wizard.seiteStartCompleted = true;
            
            setPageComplete(true);
         
          }
        }
      });
    }else{
      
    }
    
    KbEntfernenHinzufuegenAssistent wizard = (KbEntfernenHinzufuegenAssistent)getWizard();
    KbEntfernenHinzufuegenModell model = wizard.model;
    
    _tvZufluesse1.setInput(model._list.keySet());

    createLine(composite, 2);

    // set the composite as the control for this page
    setControl(composite);
    addListeners();

    parent.layout(true);
  }

  private void erzeugeTabelleTeilkonfigurationsassistenten(Composite parent)
  {
    
  }

  private void addListeners()
  {
  
    _tvZufluesse1.getTable().addListener(SWT.Selection, this);
    // kvButton.addListener(SWT.Selection, this);
    // aoeButton.addListener(SWT.Selection, this);
  }

  /**
   * @see Listener#handleEvent(Event)
   */
  public void handleEvent(Event event)
  {
    setPageComplete(isPageComplete());
    getWizard().getContainer().updateButtons();
  }

  /**
   * @see IWizardPage#canFlipToNextPage()
   */
  public boolean canFlipToNextPage()
  {    
    return false;
  }
  
  /*
   * Sets the completed field on the wizard class when all the information 
   * is entered and the wizard can be completed
   */  
  public boolean isPageComplete()
  {
//    saveDataToModel();
    
    TableItem[] items = _tvZufluesse1.getTable().getItems();

    KbEntfernenHinzufuegenAssistent wizard = (KbEntfernenHinzufuegenAssistent)getWizard();
    Map<String, File> map = new HashMap<String, File>();
    
    boolean canFinish = false;
    
    for (TableItem ti : items)
    {      
      if (ti.getChecked()){
        
        String filname = ti.getText(1);
        
        File file = wizard.model._list.get(filname);
        
        map.put(filname, file);
        canFinish = true;         
      }
    }
    if (canFinish)
      wizard.model._list = map;
    
    wizard.seiteStartCompleted = canFinish;
    return canFinish;
  }

  /*
   * Saves the uses choices from this page to the model. Called on exit of the page
   */
  private void saveDataToModel()
  {
    // Gets the model
  
  }

  private static boolean isTextNonEmpty(Text t)
  {
    if (t != null)
    {
      String s = t.getText();
      if ((s != null) && (s.trim().length() > 0))
        return true;
    }
    return false;
  }

  private void createLine(Composite parent, int ncol)
  {
    Label line = new Label(parent, SWT.SEPARATOR | SWT.HORIZONTAL | SWT.BOLD);
    GridData gridData = new GridData(GridData.FILL_HORIZONTAL);
    gridData.horizontalSpan = ncol;
    line.setLayoutData(gridData);
  }

  // /**
  // * @return true iff all fields of the return dates are set
  // */
  // private boolean isReturnDateSet()
  // {
  // if ((returnDate.getSelectionIndex() >= 0) && (returnMonth.getSelectionIndex() >= 0)
  // && (returnYear.getSelectionIndex() >= 0))
  // return true;
  // return false;
  // }

  // /*
  // * @return true if the travel and return dates are valid i.e. if the return date is the either the same or after the
  // * travel date
  // */
  // private boolean validDates()
  // {
  // if (isReturnDateSet())
  // {
  // // compare the years first, if not equal, we have an answer
  // int i = Integer.parseInt(returnYear.getText());
  // int j = Integer.parseInt(travelYear.getText());
  // if (i > j)
  // return true;
  // if (i < j)
  // return false;
  //
  // // if the years are equal, look at the month
  // i = returnMonth.getSelectionIndex();
  // j = travelMonth.getSelectionIndex();
  // if (j == -1)
  // {
  // // if the travel month still contains the initial value the selection index is still -1
  // // we need to find the index of the current month
  // String month1 = travelMonth.getText();
  // for (int k = 0; k < 12; k++)
  // if (months[k].equals(month1))
  // {
  // j = k;
  // break;
  // }
  // }
  // if (i > j)
  // return true;
  // if (i < j)
  // return false;
  //
  // // if the months are also equal, comparing the ddays we have the answer
  // i = Integer.parseInt(returnDate.getText());
  // j = Integer.parseInt(travelDate.getText());
  // if (i < j)
  // return false;
  // return true;
  // }
  // return false;
  // }

  /**
   * @author Pittner
   * 
   */
  private class TabelleTeilkonfigurationsassistentenInhaltsVersorger implements IStructuredContentProvider
  {

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.jface.viewers.IStructuredContentProvider#getElements(java.lang.Object)
     */
    public Object[] getElements(Object inputElement)
    {
      java.util.List list = (java.util.List)inputElement;

      Object[] re = new Object[list.size()];

      for (int i = 0; i < list.size(); i++)
      {
        re[i] = list.get(i);
      }

      return re;
    }

    /*
     * (non-Javadoc) *
     * 
     * @see org.eclipse.jface.viewers.IContentProvider#dispose()
     */
    public void dispose()
    {

    }

    /*
     * (non-Javadoc) *
     * 
     * @see org.eclipse.jface.viewers.IContentProvider#inputChanged(org.eclipse.jface.viewers.Viewer, java.lang.Object,
     * java.lang.Object)
     */
    public void inputChanged(Viewer viewer, Object oldInput, Object newInput)
    {

    }
  }

  /**
   * {@link LabelProvider} fr die Tabelle.
   * 
   * @author HofmannJ
   * 
   */
  private class TabelleTeilkonfigurationsassistentenDarstellungsVersorger implements ITableLabelProvider
  {

    @Override
    public Image getColumnImage(Object element, int columnIndex)
    {
      return null;
    }

    @Override
    public String getColumnText(Object element, int columnIndex)
    {
      
      String returnString = null;

      switch (columnIndex)
      {
        case 0:
          returnString = "";
          break;
        case 1:
          returnString = (String)element;
          break;
        default:
          returnString = "default";
      }

      return returnString;
    }

    @Override
    public void addListener(ILabelProviderListener listener)
    {
    }

    @Override
    public void dispose()
    {
    }

    @Override
    public boolean isLabelProperty(Object element, String property)
    {
      return false;
    }

    @Override
    public void removeListener(ILabelProviderListener listener)
    {
    }

  }

}
