/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.konfigass.konsoleAusgabeUpdateListener;

import java.util.EventObject;
import java.util.List;

import org.eclipse.core.runtime.IStatus;

import de.bsvrz.dav.daf.main.config.SystemObject;

public class KonsoleAusgabeUpdateEvent extends EventObject
{
  private static final long serialVersionUID = 1365256169927819792L;

  private IStatus _status = null;

  private long _zeitstempel = 0L;

  private String _record = "";

  public String getRecord()
  {
    return _record;
  }

  /**
   * Konstruktor
   * 
   * @param quelle
   *          Quelle des Events.
   * @param Liste
   *          der Systemobjekte.
   */
  public KonsoleAusgabeUpdateEvent(Object quelle, IStatus status, long zeitstempel)
  {
    super(quelle);
    _status = status;
    _zeitstempel = zeitstempel;

  }

  public KonsoleAusgabeUpdateEvent(Object quelle, String record)
  {
    // TODO Auto-generated constructor stub
    super(quelle);
    _record = record;
  }

  public IStatus getStatus()
  {
    return _status;
  }

  public long getZeitstempel()
  {
    return _zeitstempel;
  }

}
