/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.konfigass.managementfile;

import java.util.List;

import de.bsvrz.puk.config.main.managementfile.ConfigurationAreaManagementInfo;
import de.bsvrz.puk.config.main.managementfile.VersionInfo;

/**
 * Ein Eintrag in den Verwaltungsinformationen der Konfiguration. Fr jeden Konfigurationsbereich wird ein Eintrag erstellt. Zu jedem Eintrag wird die Pid des
 * Konfigurationsbereichs, der Speicherort der entsprechenden Konfigurationsbereichsdatei und die Versionsnummern mit ihren Aktivierungszeiten, gespeichert.
 *
 * @author Stephan Homeyer (sth), Kappich Systemberatung
 * @version $Revision: 1.3 $ / $Date: 2011/01/17 10:06:18 $ / ($Author: Sans $)
 */
public interface MyConfigurationAreaManagementInfo extends ConfigurationAreaManagementInfo
{
  /**
   * Gibt alle Versionseintrge zu diesem Konfigurationsbereich in einer Liste zurck.
   *
   * @return eine Liste aller Versionseintrge zu diesem Konfigurationsbereich
   */
  void setVersions(List<VersionInfo> versions);
  
  
  short delAllVersionInfo();
   
}
