/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.tkaaq.preferences.tree;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.swt.graphics.Image;

abstract class TreeNode implements ITreeNode 
{
	protected ITreeNode _parent;
	protected List<Object> _children;

	public TreeNode(ITreeNode parent) {
		_parent = parent;
	}

	@Override
	public Image getImage() {
		return null;
	}

	@Override
	public ITreeNode getParent() {
		return _parent;
	}

	@Override
	public boolean hasChildren() 
	{	
		if (_children == null)
			return true;
		else
			return _children.size() > 0;
	}

	@Override
	public List<Object> getChildren() 
	{
	
		if (_children != null)
			return _children;

		_children = new ArrayList<Object>();
		createChildren(_children);

		return _children;
	}
	
	/* subclasses should override this method and add the child nodes */
	protected abstract void createChildren(List<Object> children);

}
