/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.tkabasis.hierarchie;

import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import de.bsvrz.dav.daf.main.config.SystemObject;

public class HODaten
{

  private List<SystemObject> _systemObjekte = new Vector<SystemObject>();
  private Map<SystemObject, SystemObjektDaten> _systemObjektDaten = 
    new HashMap<SystemObject, SystemObjektDaten>();
  
  public List<SystemObject> getSystemObjekte()
  {
    return Collections.unmodifiableList(_systemObjekte);
  }
  
  public SystemObjektDaten getSystemObjektDaten(SystemObject objekt)
  {
    return _systemObjektDaten.get(objekt);
  }
  
  public void setSystemObjektDaten(SystemObject objekt, SystemObjektDaten daten)
  {
    _systemObjekte.remove(objekt);
    if (daten != null)
    {  
      _systemObjekte.add(objekt);
      _systemObjektDaten.put(objekt, daten);
    }
    else
    {
      _systemObjektDaten.remove(objekt);
    }
  }
  
}
