/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.tkabasis.hierarchie;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Vector;

public class MengeInfo
{
  private String _typ;
  private String _name;
  private boolean _isDynamisch;
  private List<String> _anwenderAenderbareTypen = new Vector<String>();

  public MengeInfo(String typ, String name, boolean isDynamisch, 
      String[] anwenderAenderbareTypen)
  {
    _typ = typ;
    _name = name;
    _isDynamisch = isDynamisch;
    
    if (anwenderAenderbareTypen != null)
    {
      _anwenderAenderbareTypen.addAll(Arrays.asList(anwenderAenderbareTypen));
    }
  }
  
  public String getTyp()
  {
    return _typ;
  }
  
  public String getName()
  {
    return _name;
  }
  
  public boolean isDynamisch()
  {
    return _isDynamisch;
  }
  
  public List<String> getAnwenderAenderbareTypen()
  {
    return Collections.unmodifiableList(_anwenderAenderbareTypen);
  }
  
  public boolean isAnwenderAendebar()
  {
    return (_anwenderAenderbareTypen.size() > 0);
  }
  
}
