/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.tkabasis.navigator.navigatorModell;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import de.bsvrz.dav.daf.main.config.ConfigurationArea;
import de.bsvrz.dav.daf.main.config.SystemObject;

public class KBNavigatorElement extends AbstractNavigatorElement
{
  ConfigurationArea[] configurationArea = null;
  
  public KBNavigatorElement(Object parentElement, String name, KATEGORIE kategorie, ConfigurationArea kb)
  {
   super(parentElement, name, kategorie);
    
    if (kb != null)
    {
      this.configurationArea = new ConfigurationArea[1];
      this.configurationArea[0] = kb;
    }
  }

  public List<SystemObject> getObjekte()
  {
    if (configurationArea != null)
    {
      return Arrays.asList((SystemObject[])configurationArea);
    }
    else
    {
      return Collections.emptyList();
    }
  }
  
  public ConfigurationArea getKonfigurationsBereich()
  {
    if (configurationArea != null)
    {
      return configurationArea[0];
    }
    else
    {
      return null;
    }
  }
  
  public Object getObjekt()
  {
    return configurationArea[0];
  }
  
  @Override
  public String getToolTip()
  {
    // Tooltip-Anzeige zustzlich zur 1.Zeile (Text des Items, der im Decorator hinzugefgt wird): 
    // 2.Zeile enthlt den Name des Konfigurationsbereich

    return getKonfigurationsBereich().getName();

  }
  
}
