/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.tkabasis.regeln;

import de.bsvrz.dav.daf.main.config.ConfigurationArea;

/**
 * Kapsel fr eine Instanz vom Typ IBildungsRegeln und eine Instanz vom Typ ConfigurationArea
 * 
 * @author Sans
 *
 */
public class BildungsRegelnMitKB
{
  
  /**
   * BildungsRegel-Instanz
   */
  private IBildungsRegeln _bildungsRegeln;
  
  /**
   * ConfigurationArea-Instanz  
   */
  private ConfigurationArea _kb = null;
  
  /**
   * Erzeugt eine neue Instanz vom Typ BildungsRegelnMitKB
   * 
   * @param bildungsRegeln BildungsRegel-Instanz
   * @param kb ConfigurationArea-Instanz 
   */
  public BildungsRegelnMitKB(IBildungsRegeln bildungsRegeln)
  {
    _bildungsRegeln = bildungsRegeln;
  }

  /**
   * Bestimmt die BildungsRegel-Instanz
   * 
   * @return die BildungsRegel-Instanz
   */
  public IBildungsRegeln getBildungsRegeln()
  {
    return _bildungsRegeln;
  }

  /**
   * Bestimmt die ConfigurationArea-Instanz
   * 
   * @return die ConfigurationArea-Instanz
   */
  public ConfigurationArea getKB()
  {
    return _kb;
  }

  /**
   * Setzt die aktuelle ConfigurationArea-Instanz
   * 
   * @param kb die neue aktuelle ConfigurationArea-Instanz
   */
  void setKB(ConfigurationArea kb)
  {
//    System.out.println("Setze Konfigurationsbereich " + (kb != null ? kb.getPid() : null));
    _kb = kb;
  }
  
}
