/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.tkatls.preferences.tree;

import java.util.List;

import de.bsvrz.buv.plugin.tkabasis.hierarchie.AtgInfo;
import de.bsvrz.buv.plugin.tkabasis.hierarchie.TypInfo;
import de.bsvrz.buv.plugin.tkatls.HOT_TLS;

public class RootNode extends TreeNode 
{
	private HOT_TLS[] _hotTypen;

	public RootNode(HOT_TLS[] hotTypen) {
		super(null);
		_hotTypen = hotTypen;
	}

	@Override
	public String getName() {
		return "Root";
	}
	
	@Override
	protected void createChildren(List<Object> children) 
	{
	
		//Ermitteln der Objekttypen zum HierarchieObjektTyp
		for (int i = 0; i < _hotTypen.length; i++) 
		{
			HOT_TLS hotTyp = _hotTypen[i];
			List<String> typen = hotTyp.getTypen();
			for (String objTyp : typen) 
			{
				TypInfo typInfo = hotTyp.getTypInfo(objTyp);
				List<String> atgs = typInfo.getAtgs();
				
				boolean istAtgMandatory = true;
				
				for (String atg : atgs) {
					AtgInfo ai = typInfo.getAtgInfo(atg);
					if (!ai.isMandatory()){
						istAtgMandatory = false;
					}
				}	
				if (!istAtgMandatory)
				{	
					children.add(new HotInfoNode(this, typInfo));
				}	
			}
		}
	}

}
